import { Optional } from "./optional";
import { Failure } from "../result/failure";
export declare class None<T> implements Optional<T> {
    private constructor();
    static readonly instance: None<unknown>;
    get get(): T;
    readonly value: T | null;
    getOrElse(defaultValue: T): T;
    orElse(defaultValue: Optional<T>): Optional<T>;
    readonly isDefined = false;
    readonly isEmpty = true;
    map<U>(f: (value: T) => U): Optional<U>;
    flatMap<U>(f: (value: T) => Optional<U>): Optional<U>;
    equals(compared: Optional<T>): boolean;
    fold<U>(left: () => U, right: (value: T) => U): U;
    unwrap(or: Error): T;
    toResult<E>(error: E): Failure<T, E>;
}
export declare function none<T>(): None<T>;
