import { Optional } from "./optional";
import { Result } from "../result/result";
export declare class Some<T> implements Optional<T> {
    readonly value: T;
    constructor(value: T);
    get get(): T;
    getOrElse(defaultValue: T): T;
    orElse(defaultValue: Optional<T>): Optional<T>;
    readonly isDefined = true;
    readonly isEmpty = false;
    map<U>(f: (value: T) => U): Optional<U>;
    flatMap<U>(f: (value: T) => Optional<U>): Optional<U>;
    equals(compared: Optional<T>, comparisonFunc?: (a: T, b: T) => boolean): boolean;
    fold<U>(left: () => U, right: (value: T) => U): U;
    unwrap(or: Error): T;
    toResult<E>(_: E): Result<T, E>;
}
export declare function some<T>(value: T): Some<T>;
