"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.some = exports.Some = void 0;
const success_1 = require("../result/success");
class Some {
    constructor(value) {
        this.value = value;
        this.isDefined = true;
        this.isEmpty = false;
    }
    get get() {
        return this.value;
    }
    getOrElse(defaultValue) {
        return this.value;
    }
    orElse(defaultValue) {
        return this;
    }
    map(f) {
        return new Some(f(this.value));
    }
    flatMap(f) {
        return f(this.value);
    }
    equals(compared, comparisonFunc) {
        if (compared.isEmpty)
            return false;
        if (comparisonFunc === undefined) {
            return this.value === compared.value;
        }
        return comparisonFunc(this.value, compared.value);
    }
    fold(left, right) {
        return right(this.value);
    }
    unwrap(or) {
        return this.value;
    }
    toResult(_) {
        return (0, success_1.success)(this.value);
    }
}
exports.Some = Some;
function some(value) {
    return new Some(value);
}
exports.some = some;
//# sourceMappingURL=some.js.map